% EXAMPLE_3D Demonstrates translation-invariant hereditary Haar denoising of
% Poisson image

% create true image
f = phantom3D(64,16)*100;

% generate noisy observations
x = randp(f);

% calculated denoised estimate
y = haarTIApprox(x);

% display results
for k=1:size(f,3)
  figure(k);imagesc([f(:,:,k) x(:,:,k) y(:,:,k)],[min(f(:))*.8 max(f(:))*1.2]);
  axis image;colormap gray
  title(['Slice ' num2str(k) ': Truth -- Data -- Estimate']);
end
