% Contents -- Contents of Radon
%
% This directory is a collection of routines
% for fast approximate Radon transform written by David
% Donoho. It is based on performing a kind of cartesian-
% polar conversion in the frequency domain by the use of 
% exact `scan-line' methods of sinc-interpolation.
% The whole algorithm is order n^2*log(n).
% 
%	Limitations:
%	* the transform domain is not truly polar.
%		impulses map into zig-zag lines, not sinusoids
%	* there are periodicity artifacts
% This set of routines is useful when one's goal
% is to putting constraints on the size of the Radon
% transform, rather than when interpreting the Radon
% transform visually.
% 
%
%	FastXRadon  Fast Radon transform using the X-interpolator
%
%	-> Auxiliary Routines
%	ExtendRows	Extend matrix with additional rows
%	XInterp		Interpolate in an X-pattern 
%   
%	-> Fractional Sinc Interpolation:
%	frft		Fractional Fourier Transform
%	ufrint		Exact Trigonometric Interpolation 
%
%	->	Unbiased Fourier Transform:
% 	ifft_ua		Unbiased Inverse Fourier Transform          
%	fft_ua		Unbiased Fourier Transform       
%
%  -> Adjoint of the above functions
%  t_FastXRadon Adjoint Fast Radon transform using the X-interpolator
%  t_ExtendRows Adjoint of Extend matrix by symmetry with damping
%  t_XInterp    Interpolate data to X-shaped region
%  t_ufrint     Adjoint interpolation via fractional fourier transform
%  t_ifft_ua    Adjoint of Unbiased Fast Fourier Transform
%  t_fft_ua     Adjoint of Unbiased Fast Fourier Transform
%	
%
% Part of BeamLab Version:200
% Built:Friday,23-Aug-2002 00:00:00
% This is Copyrighted Material
% For Copying permissions see COPYING.m
% Comments? e-mail beamlab@stat.stanford.edu
%
%
% Part of BeamLab Version:200
% Built:Saturday,14-Sep-2002 00:00:00
% This is Copyrighted Material
% For Copying permissions see COPYING.m
% Comments? e-mail beamlab@stat.stanford.edu
%