%  fft_ua: Unbiased Fast Fourier Transform
%  	x=ifft_ua(y)
%  Inputs
% 	y	dyadic row vector
%  Outputs
% 	x	dyadic column vector
%  Description
% 	View the entries of x as containing
% 	   x'(-n/2), ... , x'(n/2-1)
%    This routine takes an array y containing
%  the values
% 	   y'(-n/2), ... , y'(n/2-1)
%  where
% 	   y'(k) = Sum( x'(j) exp( -2*pi*i*k*j/n) : -n/2 <= j < n/2)
%  and recovers the values x'.  That is, 
% 	   x'(j) = n^{-1} *Sum( y'(k) exp(2*pi*i*k*j/n) : -n/2 <= k < n/2)
% 
%
%
% Part of BeamLab Version:200
% Built:Friday,23-Aug-2002 00:00:00
% This is Copyrighted Material
% For Copying permissions see COPYING.m
% Comments? e-mail beamlab@stat.stanford.edu
%
%
% Part of BeamLab Version:200
% Built:Saturday,14-Sep-2002 00:00:00
% This is Copyrighted Material
% For Copying permissions see COPYING.m
% Comments? e-mail beamlab@stat.stanford.edu
%