void pruneTree3D(double ***x, int m1, int m2, int m3, double pen, double ***y, char *noiseType)
{
  int i1,i2,i3,iL,iiL,L,nElts;
  int j,k1,k2,k3, iL2, dyadLen,dyadVol;
  double pMerge,pSplit,pWedge;
  double ***xScaling, ***xScalingPrev;
  double ****optProb, ****mergeProb, ****waveletScale, ****splitDecision;
  double ****waveletA, ****waveletB, ****waveletC, ****waveletD;	
  double ****waveletE, ****waveletF, ****waveletG;
  double xD1, xD2, xD3, xD4, xD5, xD6, xD7, xD8;

  printf("pen = %f\n",pen);

  nElts = m1*m2*m3;
  L = (int) floor(log(min(min(m1,m2),m3))/log((double)2));

  xScaling = (double ***)mxCalloc(m1,sizeof(double**));
  xScalingPrev = (double ***)mxCalloc(m1,sizeof(double**));

  waveletScale = (double ****)mxCalloc(m1,sizeof(double***));
  waveletA = (double ****)mxCalloc(m1,sizeof(double***));
  waveletB = (double ****)mxCalloc(m1,sizeof(double***));
  waveletC = (double ****)mxCalloc(m1,sizeof(double***));
  waveletD = (double ****)mxCalloc(m1,sizeof(double***));
  waveletE = (double ****)mxCalloc(m1,sizeof(double***));
  waveletF = (double ****)mxCalloc(m1,sizeof(double***));
  waveletG = (double ****)mxCalloc(m1,sizeof(double***));

  splitDecision = (double ****)mxCalloc(m1,sizeof(double***));
  optProb = (double ****)mxCalloc(m1,sizeof(double***));
  mergeProb = (double ****)mxCalloc(m1,sizeof(double***));

  for (i1 = 0; i1 < m1; i1++) {
    xScaling[i1] = (double **)mxCalloc(m2,sizeof(double*));
    xScalingPrev[i1] = (double **)mxCalloc(m2,sizeof(double*));

    waveletScale[i1] = (double ***)mxCalloc(m2,sizeof(double**));
    waveletA[i1] = (double ***)mxCalloc(m2,sizeof(double**));
    waveletB[i1] = (double ***)mxCalloc(m2,sizeof(double**));
    waveletC[i1] = (double ***)mxCalloc(m2,sizeof(double**));
    waveletD[i1] = (double ***)mxCalloc(m2,sizeof(double**));
    waveletE[i1] = (double ***)mxCalloc(m2,sizeof(double**));
    waveletF[i1] = (double ***)mxCalloc(m2,sizeof(double**));
    waveletG[i1] = (double ***)mxCalloc(m2,sizeof(double**));

    splitDecision[i1] = (double ***)mxCalloc(m2,sizeof(double**));
    optProb[i1] = (double ***)mxCalloc(m2,sizeof(double**));
    mergeProb[i1] = (double ***)mxCalloc(m2,sizeof(double**));
    for (i2 = 0; i2 <m2; i2++) {
      xScaling[i1][i2] = (double *)mxCalloc(m3,sizeof(double));
      xScalingPrev[i1][i2] = (double *)mxCalloc(m3,sizeof(double));

      waveletScale[i1][i2] = (double **)mxCalloc(m3,sizeof(double*));
      waveletA[i1][i2] = (double **)mxCalloc(m3,sizeof(double*));
      waveletB[i1][i2] = (double **)mxCalloc(m3,sizeof(double*));
      waveletC[i1][i2] = (double **)mxCalloc(m3,sizeof(double*));
      waveletD[i1][i2] = (double **)mxCalloc(m3,sizeof(double*));
      waveletE[i1][i2] = (double **)mxCalloc(m3,sizeof(double*));
      waveletF[i1][i2] = (double **)mxCalloc(m3,sizeof(double*));
      waveletG[i1][i2] = (double **)mxCalloc(m3,sizeof(double*));

      splitDecision[i1][i2] = (double **)mxCalloc(m3,sizeof(double*));
      optProb[i1][i2] = (double **)mxCalloc(m3,sizeof(double*));
      mergeProb[i1][i2] = (double **)mxCalloc(m3,sizeof(double*));

      for (i3 = 0; i3 <m3; i3++) {
        waveletScale[i1][i2][i3] = (double *)mxCalloc(L,sizeof(double));
        waveletA[i1][i2][i3] = (double *)mxCalloc(L,sizeof(double));
        waveletB[i1][i2][i3] = (double *)mxCalloc(L,sizeof(double));
        waveletC[i1][i2][i3] = (double *)mxCalloc(L,sizeof(double));
        waveletD[i1][i2][i3] = (double *)mxCalloc(L,sizeof(double));
        waveletE[i1][i2][i3] = (double *)mxCalloc(L,sizeof(double));
        waveletF[i1][i2][i3] = (double *)mxCalloc(L,sizeof(double));
        waveletG[i1][i2][i3] = (double *)mxCalloc(L,sizeof(double));

        splitDecision[i1][i2][i3] = (double *)mxCalloc(L,sizeof(double));
        optProb[i1][i2][i3] = (double *)mxCalloc(L+1,sizeof(double));
        mergeProb[i1][i2][i3] = (double *)mxCalloc(L+1,sizeof(double));

      }
    }
  }
   
  /* initialize variables */
  for (i1 = 0; i1 < m1; i1++) {
    for (i2 = 0; i2 < m2; i2++) {
      for (i3 = 0; i3 < m3; i3++) {
        xScalingPrev[i1][i2][i3] = x[i1][i2][i3];
        y[i1][i2][i3] = x[i1][i2][i3];
        optProb[i1][i2][i3][0] = logLike3D(x,x,1,1,1,i1,i2,i3,noiseType)-pen;
        if (strcmp(noiseType,"Poisson")==0) {
          mergeProb[i1][i2][i3][0] = 0;
        }
        else if (strcmp(noiseType,"Gaussian")==0) {
          mergeProb[i1][i2][i3][0] = -pow(x[i1][i2][i3],2.0);
        }
      }
    }
  }


  for (iL=0;iL<L;iL++) {
    dyadLen = (int)pow(2.0,iL+1);
    dyadVol = (int)pow(dyadLen,3.0);
    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
        for (i3 = 0; i3 < m3; i3++) {
          k1 = (int)mod(i1+dyadLen/2,m1);
          k2 = (int)mod(i2+dyadLen/2,m2);
          k3 = (int)mod(i3+dyadLen/2,m3);

          /* calculate current scaling coefficient */
          xScaling[i1][i2][i3] = (xScalingPrev[i1][i2][i3]+xScalingPrev[i1][i2][k3]+
                                  xScalingPrev[i1][k2][i3]+xScalingPrev[i1][k2][k3]+
                                  xScalingPrev[k1][i2][i3]+xScalingPrev[k1][i2][k3]+
                                  xScalingPrev[k1][k2][i3]+xScalingPrev[k1][k2][k3])/8.0;

          /* log probability of merging */
          if (strcmp(noiseType,"Poisson")==0) {
            pMerge = (mergeProb[i1][i2][i3][iL] + mergeProb[i1][i2][k3][iL] +
                      mergeProb[i1][k2][i3][iL] + mergeProb[i1][k2][k3][iL] +
                      mergeProb[k1][i2][i3][iL] + mergeProb[k1][i2][k3][iL] +
                      mergeProb[k1][k2][i3][iL] + mergeProb[k1][k2][k3][iL] -
                      xScaling[i1][i2][i3]*dyadVol*
                      (1.0-log(xScaling[i1][i2][i3]*dyadVol)-log(1.0/8.0))
                      - pen);
          }
          else if (strcmp(noiseType,"Gaussian")==0) {
            pMerge = (mergeProb[i1][i2][i3][iL] + mergeProb[i1][i2][k3][iL] +
                      mergeProb[i1][k2][i3][iL] + mergeProb[i1][k2][k3][iL] +
                      mergeProb[k1][i2][i3][iL] + mergeProb[k1][i2][k3][iL] +
                      mergeProb[k1][k2][i3][iL] + mergeProb[k1][k2][k3][iL]
                      + pow(xScaling[i1][i2][i3],2.0)*dyadVol
                      - pen);
          }

          /* log probability of splitting */
          pSplit = (optProb[i1][i2][i3][iL] + optProb[i1][i2][k3][iL] +
                    optProb[i1][k2][i3][iL] + optProb[i1][k2][k3][iL] +
                    optProb[k1][i2][i3][iL] + optProb[k1][i2][k3][iL] +
                    optProb[k1][k2][i3][iL] + optProb[k1][k2][k3][iL]);

          /* terms of merge log probability needed to calculated pMerge at next scale */
          if (strcmp(noiseType,"Poisson")==0) {
            mergeProb[i1][i2][i3][iL+1] = (mergeProb[i1][i2][i3][iL] + mergeProb[i1][i2][k3][iL] +
                                           mergeProb[i1][k2][i3][iL] + mergeProb[i1][k2][k3][iL] +
                                           mergeProb[k1][i2][i3][iL] + mergeProb[k1][i2][k3][iL] +
                                           mergeProb[k1][k2][i3][iL] + mergeProb[k1][k2][k3][iL] +
                                           xScaling[i1][i2][i3]*dyadVol*log(1.0/8.0));
          }
          else if (strcmp(noiseType,"Gaussian")==0) {
            mergeProb[i1][i2][i3][iL+1] = (mergeProb[i1][i2][i3][iL] + mergeProb[i1][i2][k3][iL] +
                                           mergeProb[i1][k2][i3][iL] + mergeProb[i1][k2][k3][iL] +
                                           mergeProb[k1][i2][i3][iL] + mergeProb[k1][i2][k3][iL] +
                                           mergeProb[k1][k2][i3][iL] + mergeProb[k1][k2][k3][iL]);
          }

          /* "wavelet" coefficients */
          waveletA[i1][i2][i3][iL] = ((xScalingPrev[i1][i2][i3]+xScalingPrev[i1][i2][k3]+
                                       xScalingPrev[i1][k2][i3]+xScalingPrev[i1][k2][k3])/4.0
                                      -xScaling[i1][i2][i3]);
          waveletB[i1][i2][i3][iL] = ((xScalingPrev[i1][i2][i3]+xScalingPrev[i1][i2][k3]+
                                       xScalingPrev[k1][i2][i3]+xScalingPrev[k1][i2][k3])/4.0
                                      -xScaling[i1][i2][i3]);
          waveletC[i1][i2][i3][iL] = ((xScalingPrev[i1][i2][i3]+xScalingPrev[k1][i2][i3]+
                                       xScalingPrev[i1][k2][i3]+xScalingPrev[k1][k2][i3])/4.0
                                      -xScaling[i1][i2][i3]);
          waveletD[i1][i2][i3][iL] = ((xScalingPrev[i1][i2][i3]+xScalingPrev[i1][i2][k3]+
                                       xScalingPrev[k1][k2][i3]+xScalingPrev[k1][k2][k3])/4.0
                                      -xScaling[i1][i2][i3]);
          waveletE[i1][i2][i3][iL] = ((xScalingPrev[i1][i2][i3]+xScalingPrev[i1][k2][i3]+
                                       xScalingPrev[k1][i2][k3]+xScalingPrev[k1][k2][k3])/4.0
                                      -xScaling[i1][i2][i3]);
          waveletF[i1][i2][i3][iL] = ((xScalingPrev[i1][i2][i3]+xScalingPrev[k1][i2][i3]+
                                       xScalingPrev[i1][k2][k3]+xScalingPrev[k1][k2][k3])/4.0
                                      -xScaling[i1][i2][i3]);
          waveletG[i1][i2][i3][iL] = ((xScalingPrev[i1][i2][i3]+xScalingPrev[k1][i2][k3]+
                                       xScalingPrev[k1][k2][i3]+xScalingPrev[i1][k2][k3])/4.0
                                      -xScaling[i1][i2][i3]);
        

          /* decide whether to split or merge, save decision and associated
            log probability */
          if (pMerge >= pSplit) {
            splitDecision[i1][i2][i3][iL] = 0;
            optProb[i1][i2][i3][iL+1] = pMerge;
          }
          else {
            splitDecision[i1][i2][i3][iL] = 1.0;
            optProb[i1][i2][i3][iL+1] = pSplit;
          }
          waveletScale[i1][i2][i3][iL] = 1.0;
        }
      }
    }	

    /* set up scaling coefficients for next scale */
    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
        for (i3 = 0; i3 < m3; i3++) {
          xScalingPrev[i1][i2][i3] = xScaling[i1][i2][i3];
        }
      }
    }
  }

  /* initial estimate is coarse scale scaling coefficients */
  for (i1 = 0; i1 < m1; i1++) {
    for (i2 = 0; i2 < m2; i2++) {
      for (i3 = 0; i3 < m3; i3++) {
        y[i1][i2][i3] = xScaling[i1][i2][i3];
      }
    }
  }

  for (iL=L-1; iL>=0; iL--) {
    dyadLen = (int)pow(2.0,iL+1);

    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
        for (i3 = 0; i3 < m3; i3++) {
          k1 = (int)mod(i1+dyadLen/2,m1);
          k2 = (int)mod(i2+dyadLen/2,m2);
          k3 = (int)mod(i3+dyadLen/2,m3);
          /* if the split decision is zero, then the associated wavelet should
           be set to zero. */
          if (splitDecision[i1][i2][i3][iL]==0) {
            waveletScale[i1][i2][i3][iL] = 0;
          }
          if (iL > 0) {
            /* threshold wavelet coefficient based on ancestors' split/merge
            decisions */
            waveletScale[i1][i2][i3][iL-1] = waveletScale[i1][i2][i3][iL-1]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3][iL]));
            waveletScale[i1][i2][k3][iL-1] = waveletScale[i1][i2][k3][iL-1]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3][iL]));
            waveletScale[i1][k2][i3][iL-1] = waveletScale[i1][k2][i3][iL-1]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3][iL]));
            waveletScale[i1][k2][k3][iL-1] = waveletScale[i1][k2][k3][iL-1]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3][iL]));
            waveletScale[k1][i2][i3][iL-1] = waveletScale[k1][i2][i3][iL-1]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3][iL]));
            waveletScale[k1][i2][k3][iL-1] = waveletScale[k1][i2][k3][iL-1]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3][iL]));
            waveletScale[k1][k2][i3][iL-1] = waveletScale[k1][k2][i3][iL-1]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3][iL]));
            waveletScale[k1][k2][k3][iL-1] = waveletScale[k1][k2][k3][iL-1]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3][iL]));
          }
        }
      }
    }

    /* construct estimate based on wavelet coefficients and thresholds */
    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
        for (i3 = 0; i3 < m3; i3++) {
          k1 = (int)mod(i1-dyadLen/2,m1);
          k2 = (int)mod(i2-dyadLen/2,m2);
          k3 = (int)mod(i3-dyadLen/2,m3);

          xD1 = (waveletA[i1][i2][i3][iL]+
                 waveletB[i1][i2][i3][iL]+
                 waveletC[i1][i2][i3][iL]+
                 waveletD[i1][i2][i3][iL]+
                 waveletE[i1][i2][i3][iL]+
                 waveletF[i1][i2][i3][iL]+
                 waveletG[i1][i2][i3][iL])*(waveletScale[i1][i2][i3][iL]);

          xD2 = (waveletA[i1][i2][k3][iL]+
                 waveletB[i1][i2][k3][iL]+
                 -waveletC[i1][i2][k3][iL]+
                 waveletD[i1][i2][k3][iL]+
                 -waveletE[i1][i2][k3][iL]+
                 -waveletF[i1][i2][k3][iL]+
                 -waveletG[i1][i2][k3][iL])*(waveletScale[i1][i2][k3][iL]);

          xD3 = (waveletA[i1][k2][i3][iL]+
                 -waveletB[i1][k2][i3][iL]+
                 waveletC[i1][k2][i3][iL]+
                 -waveletD[i1][k2][i3][iL]+
                 waveletE[i1][k2][i3][iL]+
                 -waveletF[i1][k2][i3][iL]+
                 -waveletG[i1][k2][i3][iL])*(waveletScale[i1][k2][i3][iL]);

          xD4 = (waveletA[i1][k2][k3][iL]+
                 -waveletB[i1][k2][k3][iL]+
                 -waveletC[i1][k2][k3][iL]+
                 -waveletD[i1][k2][k3][iL]+
                 -waveletE[i1][k2][k3][iL]+
                 waveletF[i1][k2][k3][iL]+
                 waveletG[i1][k2][k3][iL])*(waveletScale[i1][k2][k3][iL]);

          xD5 = (-waveletA[k1][i2][i3][iL]+
                 waveletB[k1][i2][i3][iL]+
                 waveletC[k1][i2][i3][iL]+
                 -waveletD[k1][i2][i3][iL]+
                 -waveletE[k1][i2][i3][iL]+
                 waveletF[k1][i2][i3][iL]+
                 -waveletG[k1][i2][i3][iL])*(waveletScale[k1][i2][i3][iL]);

          xD6 = (-waveletA[k1][i2][k3][iL]+
                 waveletB[k1][i2][k3][iL]+
                 -waveletC[k1][i2][k3][iL]+
                 -waveletD[k1][i2][k3][iL]+
                 waveletE[k1][i2][k3][iL]+
                 -waveletF[k1][i2][k3][iL]+
                 waveletG[k1][i2][k3][iL])*(waveletScale[k1][i2][k3][iL]);

          xD7 = (-waveletA[k1][k2][i3][iL]+
                 -waveletB[k1][k2][i3][iL]+
                 waveletC[k1][k2][i3][iL]+
                 waveletD[k1][k2][i3][iL]+
                 -waveletE[k1][k2][i3][iL]+
                 -waveletF[k1][k2][i3][iL]+
                 waveletG[k1][k2][i3][iL])*(waveletScale[k1][k2][i3][iL]);

          xD8 = (-waveletA[k1][k2][k3][iL]+
                 -waveletB[k1][k2][k3][iL]+
                 -waveletC[k1][k2][k3][iL]+
                 waveletD[k1][k2][k3][iL]+
                 waveletE[k1][k2][k3][iL]+
                 waveletF[k1][k2][k3][iL]+
                 -waveletG[k1][k2][k3][iL])*(waveletScale[k1][k2][k3][iL]);


          xScaling[i1][i2][i3] = (y[i1][i2][i3]+xD1 +
                                  y[i1][i2][k3]+xD2 +
                                  y[i1][k2][i3]+xD3 +
                                  y[i1][k2][k3]+xD4 +
                                  y[k1][i2][i3]+xD5 +
                                  y[k1][i2][k3]+xD6 +
                                  y[k1][k2][i3]+xD7 +
                                  y[k1][k2][k3]+xD8)/8.0;

          xScaling[i1][i2][i3] = (y[i1][i2][k3]+xD2)/1.0;
          
        }
      }
    }
    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
        for (i3 = 0; i3 < m3; i3++) {
          y[i1][i2][i3] = xScaling[i1][i2][i3];
	  /*	  if ((i3+1)==m3)
	    y[i1][i2][i3] = xScaling[i1][i2][0];
	  else
	  y[i1][i2][i3] = xScaling[i1][i2][i3+1];*/
        }
      }
    }
  }
}
