struct waveletCoeff{ 
  double A, B, C, D, E, F, G;
};

void pruneTree3D_BigData(double ***x, int m1, int m2, int m3, 
			 double pen, double ***y, char *noiseType)
{
  int i1,i2,i3,iL,L,nElts;
  char fileName[32];
  FILE *myFile;
  double mergeProbNext, xScaling;
  int j,k1,k2,k3, iL2, dyadLen,dyadVol;
  double pMerge,pSplit;
  double ***optProb, ***mergeProb, ***waveletScale, ***xScalingPrev;
  short int *splitDecision;
  struct waveletCoeff ***wavelet;
  double xD1, xD2, xD3, xD4, xD5, xD6, xD7, xD8;

  FILE *optProbNextFile, *mergeProbNextFile, *xScalingFile;
  /*double ***optProbNext, mergeProbNext, ***xScaling;*/
  double ***waveletScaleNext;


  nElts = m1*m2*m3;
  L = (int) floor(log(min(min(m1,m2),m3))/log((double)2));

  splitDecision = (short int *)mxCalloc(1,sizeof(short int));

  xScalingPrev = (double ***)mxCalloc(m1,sizeof(double**));
  wavelet = (struct waveletCoeff ***)mxCalloc(m1,sizeof(struct waveletCoeff **));
  optProb = (double ***)mxCalloc(m1,sizeof(double**));
  mergeProb = (double ***)mxCalloc(m1,sizeof(double**));

  /*optProbNext = (double ***)mxCalloc(m1,sizeof(double**));
    mergeProbNext = (double ***)mxCalloc(m1,sizeof(double**));
    xScaling = (double ***)mxCalloc(m1,sizeof(double**));*/


  for (i1 = 0; i1 < m1; i1++) {
    xScalingPrev[i1] = (double **)mxCalloc(m2,sizeof(double*));
    wavelet[i1] = (struct waveletCoeff **)mxCalloc(m2,sizeof(struct waveletCoeff*));
    optProb[i1] = (double **)mxCalloc(m2,sizeof(double*));
    mergeProb[i1] = (double **)mxCalloc(m2,sizeof(double*));
    /*optProbNext[i1] = (double **)mxCalloc(m2,sizeof(double*));
      mergeProbNext[i1] = (double **)mxCalloc(m2,sizeof(double*));
      xScaling[i1] = (double **)mxCalloc(m2,sizeof(double*));*/

    for (i2 = 0; i2 <m2; i2++) {
      xScalingPrev[i1][i2] = (double *)mxCalloc(m3,sizeof(double));
      wavelet[i1][i2] = (struct waveletCoeff *)mxCalloc(m3,sizeof(struct waveletCoeff));
      optProb[i1][i2] = (double *)mxCalloc(m3,sizeof(double));
      mergeProb[i1][i2] = (double *)mxCalloc(m3,sizeof(double));
      /*optProbNext[i1][i2] = (double *)mxCalloc(m3,sizeof(double));
	mergeProbNext[i1][i2] = (double *)mxCalloc(m3,sizeof(double));
	xScaling[i1][i2] = (double *)mxCalloc(m3,sizeof(double));*/
    }
  }

  /* initialize variables */
  for (i1 = 0; i1 < m1; i1++) {
    for (i2 = 0; i2 < m2; i2++) {
      for (i3 = 0; i3 < m3; i3++) {
        xScalingPrev[i1][i2][i3] = x[i1][i2][i3];
        optProb[i1][i2][i3] = logLike3D(x,x,1,1,1,i1,i2,i3,noiseType)-pen;
        if (strcmp(noiseType,"Poisson")==0) {
          mergeProb[i1][i2][i3] = 0;
        }
        else if (strcmp(noiseType,"Gaussian")==0) {
          mergeProb[i1][i2][i3] = -pow(x[i1][i2][i3],2.0);
        }
      }
    }
  }


  for (iL=0;iL<L;iL++) {
    dyadLen = (int)pow(2.0,iL+1);
    dyadVol = (int)pow(dyadLen,3.0);

    sprintf(fileName,".splitDecisions%d.dat",iL);
    myFile = fopen(fileName,"w");

    sprintf(fileName,".optProbNext%d.dat",iL);
    optProbNextFile = fopen(fileName,"w");

    sprintf(fileName,".mergeProbNext%d.dat",iL);
    mergeProbNextFile = fopen(fileName,"w");

    sprintf(fileName,".xScaling%d.dat",iL);
    xScalingFile = fopen(fileName,"w");

    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
        for (i3 = 0; i3 < m3; i3++) {
          k1 = (int)mod(i1+dyadLen/2,m1);
          k2 = (int)mod(i2+dyadLen/2,m2);
          k3 = (int)mod(i3+dyadLen/2,m3);
	  
          xScaling = (xScalingPrev[i1][i2][i3]+xScalingPrev[i1][i2][k3]+
		      xScalingPrev[i1][k2][i3]+xScalingPrev[i1][k2][k3]+
		      xScalingPrev[k1][i2][i3]+xScalingPrev[k1][i2][k3]+
		      xScalingPrev[k1][k2][i3]+xScalingPrev[k1][k2][k3])/8.0;
	  fwrite(&xScaling,sizeof(double),1,xScalingFile);

	  pMerge = (mergeProb[i1][i2][i3] + mergeProb[i1][i2][k3] +
		    mergeProb[i1][k2][i3] + mergeProb[i1][k2][k3] +
		    mergeProb[k1][i2][i3] + mergeProb[k1][i2][k3] +
		    mergeProb[k1][k2][i3] + mergeProb[k1][k2][k3]);
          if (strcmp(noiseType,"Poisson")==0) {
            pMerge =  (pMerge - xScaling*dyadVol*
		       (1.0-log(xScaling*dyadVol)-log(1.0/8.0))
		       - pen);
          }
          else if (strcmp(noiseType,"Gaussian")==0) {
            pMerge = (pMerge + pow(xScaling,2.0)*dyadVol
                      - pen);
          }

          pSplit = (optProb[i1][i2][i3] + optProb[i1][i2][k3] +
                    optProb[i1][k2][i3] + optProb[i1][k2][k3] +
                    optProb[k1][i2][i3] + optProb[k1][i2][k3] +
                    optProb[k1][k2][i3] + optProb[k1][k2][k3]);

	  mergeProbNext = (mergeProb[i1][i2][i3] + mergeProb[i1][i2][k3] +
			   mergeProb[i1][k2][i3] + mergeProb[i1][k2][k3] +
			   mergeProb[k1][i2][i3] + mergeProb[k1][i2][k3] +
			   mergeProb[k1][k2][i3] + mergeProb[k1][k2][k3]);
          if (strcmp(noiseType,"Poisson")==0) {
            mergeProbNext = (mergeProbNext +
			     xScaling*dyadVol*log(1.0/8.0));
          }
	  fwrite(&mergeProbNext,sizeof(double),1,mergeProbNextFile);

          wavelet[i1][i2][i3].A = ((xScalingPrev[i1][i2][i3]+xScalingPrev[i1][i2][k3]+
				    xScalingPrev[i1][k2][i3]+xScalingPrev[i1][k2][k3])/4.0
				   -xScaling);
          wavelet[i1][i2][i3].B = ((xScalingPrev[i1][i2][i3]+xScalingPrev[i1][i2][k3]+
				    xScalingPrev[k1][i2][i3]+xScalingPrev[k1][i2][k3])/4.0
				   -xScaling);
          wavelet[i1][i2][i3].C = ((xScalingPrev[i1][i2][i3]+xScalingPrev[k1][i2][i3]+
				    xScalingPrev[i1][k2][i3]+xScalingPrev[k1][k2][i3])/4.0
				   -xScaling);
          wavelet[i1][i2][i3].D = ((xScalingPrev[i1][i2][i3]+xScalingPrev[i1][i2][k3]+
				    xScalingPrev[k1][k2][i3]+xScalingPrev[k1][k2][k3])/4.0
				   -xScaling);
          wavelet[i1][i2][i3].E = ((xScalingPrev[i1][i2][i3]+xScalingPrev[i1][k2][i3]+
				    xScalingPrev[k1][i2][k3]+xScalingPrev[k1][k2][k3])/4.0
				   -xScaling);
          wavelet[i1][i2][i3].F = ((xScalingPrev[i1][i2][i3]+xScalingPrev[k1][i2][i3]+
				    xScalingPrev[i1][k2][k3]+xScalingPrev[k1][k2][k3])/4.0
				   -xScaling);
          wavelet[i1][i2][i3].G = ((xScalingPrev[i1][i2][i3]+xScalingPrev[k1][i2][k3]+
				    xScalingPrev[k1][k2][i3]+xScalingPrev[i1][k2][k3])/4.0
				   -xScaling);
        

          if (pMerge >= pSplit) {
            splitDecision[0] = 0;
            /*optProbNext[i1][i2][i3] = pMerge;*/
	    fwrite(&pMerge,sizeof(double),1,optProbNextFile);
          }
          else {
            splitDecision[0] = 1;
            /*optProbNext[i1][i2][i3] = pSplit;*/
	    fwrite(&pSplit,sizeof(double),1,optProbNextFile);
          }
	  fwrite(splitDecision,sizeof(short int),1,myFile);

	  if (iL==(L-1)) {
	    y[i1][i2][i3] = xScaling;
	  }

        }
      }
    }	

    fclose(myFile);
    fclose(optProbNextFile);
    fclose(mergeProbNextFile);
    fclose(xScalingFile);

    sprintf(fileName,".wavelets%d.dat",iL);
    myFile = fopen(fileName,"w");

    sprintf(fileName,".optProbNext%d.dat",iL);
    optProbNextFile = fopen(fileName,"r");

    sprintf(fileName,".mergeProbNext%d.dat",iL);
    mergeProbNextFile = fopen(fileName,"r");

    sprintf(fileName,".xScaling%d.dat",iL);
    xScalingFile = fopen(fileName,"r");
    
    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
	fwrite(wavelet[i1][i2],sizeof(struct waveletCoeff),m3,myFile);
        for (i3 = 0; i3 < m3; i3++) {
          /* xScalingPrev[i1][i2][i3] = xScaling[i1][i2][i3];
	     mergeProb[i1][i2][i3] = mergeProbNext[i1][i2][i3];
	     optProb[i1][i2][i3] = optProbNext[i1][i2][i3];*/
	  fread(&(xScalingPrev[i1][i2][i3]),sizeof(double),1,xScalingFile);
	  fread(&(optProb[i1][i2][i3]),sizeof(double),1,optProbNextFile);
	  fread(&(mergeProb[i1][i2][i3]),sizeof(double),1,mergeProbNextFile);

        }
      }
    }
    fclose(myFile);
    fclose(xScalingFile);
    sprintf(fileName,".xScaling%d.dat",iL);
    remove(fileName);
    fclose(mergeProbNextFile);
    sprintf(fileName,".mergeProbNext%d.dat",iL);
    remove(fileName);
    fclose(optProbNextFile);
    sprintf(fileName,".optProbNext%d.dat",iL);
    remove(fileName);

    printf("grew level %d\n",iL);
  }

  for (i1 = 0; i1 < m1; i1++) {
    for (i2 = 0; i2 < m2; i2++) {
      mxFree(optProb[i1][i2]);
      mxFree(mergeProb[i1][i2]);
    }
    mxFree(optProb[i1]);
    mxFree(mergeProb[i1]);
  }
  mxFree(optProb);
  mxFree(mergeProb);

  waveletScale = (double ***)mxCalloc(m1,sizeof(double**));
  waveletScaleNext = (double ***)mxCalloc(m1,sizeof(double**));
  for (i1 = 0; i1 < m1; i1++) {
    waveletScale[i1] = (double **)mxCalloc(m2,sizeof(double*));
    waveletScaleNext[i1] = (double **)mxCalloc(m2,sizeof(double*));
    for (i2 = 0; i2 < m2; i2++) {
      waveletScale[i1][i2] = (double *)mxCalloc(m3,sizeof(double));
      waveletScaleNext[i1][i2] = (double *)mxCalloc(m3,sizeof(double));
      for (i3 = 0; i3 < m3; i3++) {
	waveletScale[i1][i2][i3] = 1.0;
      }
    }
  }

  /* start the pruning */
  for (iL=L-1; iL>=0; iL--) {
    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
	for (i3 = 0; i3 < m3; i3++) {
	  waveletScaleNext[i1][i2][i3] = 1.0;
	}
      }
    }

    dyadLen = (int)pow(2.0,iL+1);

    sprintf(fileName,".splitDecisions%d.dat",iL);
    myFile = fopen(fileName,"r");

    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
        for (i3 = 0; i3 < m3; i3++) {
	  fread(splitDecision,sizeof(short int),1,myFile);
          k1 = (int)mod(i1+dyadLen/2,m1);
          k2 = (int)mod(i2+dyadLen/2,m2);
          k3 = (int)mod(i3+dyadLen/2,m3);

          if (splitDecision[0]==0) {
            waveletScale[i1][i2][i3] = 0;
          }
          if (iL > 0) {

            waveletScaleNext[i1][i2][i3] = waveletScaleNext[i1][i2][i3]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3]));
            waveletScaleNext[i1][i2][k3] = waveletScaleNext[i1][i2][k3]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3]));
            waveletScaleNext[i1][k2][i3] = waveletScaleNext[i1][k2][i3]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3]));
            waveletScaleNext[i1][k2][k3] = waveletScaleNext[i1][k2][k3]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3]));
            waveletScaleNext[k1][i2][i3] = waveletScaleNext[k1][i2][i3]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3]));
            waveletScaleNext[k1][i2][k3] = waveletScaleNext[k1][i2][k3]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3]));
            waveletScaleNext[k1][k2][i3] = waveletScaleNext[k1][k2][i3]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3]));
            waveletScaleNext[k1][k2][k3] = waveletScaleNext[k1][k2][k3]
              - (1.0/8.0*(1.0-waveletScale[i1][i2][i3]));
          }
        }
      }
    }
    fclose(myFile);
    remove(fileName);

    sprintf(fileName,".wavelets%d.dat",iL);
    myFile = fopen(fileName,"r");
    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
	fread(wavelet[i1][i2],sizeof(struct waveletCoeff),m3,myFile);
      }
    }
    fclose(myFile);
    remove(fileName);

    /* construct estimate based on wavelet coefficients and thresholds */
    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
        for (i3 = 0; i3 < m3; i3++) {
          k1 = (int)mod(i1-dyadLen/2,m1);
          k2 = (int)mod(i2-dyadLen/2,m2);
          k3 = (int)mod(i3-dyadLen/2,m3);

          xD1 = (wavelet[i1][i2][i3].A+
                 wavelet[i1][i2][i3].B+
                 wavelet[i1][i2][i3].C+
                 wavelet[i1][i2][i3].D+
                 wavelet[i1][i2][i3].E+
                 wavelet[i1][i2][i3].F+
                 wavelet[i1][i2][i3].G)*(waveletScale[i1][i2][i3]);

          xD2 = (wavelet[i1][i2][k3].A+
                 wavelet[i1][i2][k3].B+
                 -wavelet[i1][i2][k3].C+
                 wavelet[i1][i2][k3].D+
                 -wavelet[i1][i2][k3].E+
                 -wavelet[i1][i2][k3].F+
                 -wavelet[i1][i2][k3].G)*(waveletScale[i1][i2][k3]);

          xD3 = (wavelet[i1][k2][i3].A+
                 -wavelet[i1][k2][i3].B+
                 wavelet[i1][k2][i3].C+
                 -wavelet[i1][k2][i3].D+
                 wavelet[i1][k2][i3].E+
                 -wavelet[i1][k2][i3].F+
                 -wavelet[i1][k2][i3].G)*(waveletScale[i1][k2][i3]);

          xD4 = (wavelet[i1][k2][k3].A+
                 -wavelet[i1][k2][k3].B+
                 -wavelet[i1][k2][k3].C+
                 -wavelet[i1][k2][k3].D+
                 -wavelet[i1][k2][k3].E+
                 wavelet[i1][k2][k3].F+
                 wavelet[i1][k2][k3].G)*(waveletScale[i1][k2][k3]);

          xD5 = (-wavelet[k1][i2][i3].A+
                 wavelet[k1][i2][i3].B+
                 wavelet[k1][i2][i3].C+
                 -wavelet[k1][i2][i3].D+
                 -wavelet[k1][i2][i3].E+
                 wavelet[k1][i2][i3].F+
                 -wavelet[k1][i2][i3].G)*(waveletScale[k1][i2][i3]);

          xD6 = (-wavelet[k1][i2][k3].A+
                 wavelet[k1][i2][k3].B+
                 -wavelet[k1][i2][k3].C+
                 -wavelet[k1][i2][k3].D+
                 wavelet[k1][i2][k3].E+
                 -wavelet[k1][i2][k3].F+
                 wavelet[k1][i2][k3].G)*(waveletScale[k1][i2][k3]);

          xD7 = (-wavelet[k1][k2][i3].A+
                 -wavelet[k1][k2][i3].B+
                 wavelet[k1][k2][i3].C+
                 wavelet[k1][k2][i3].D+
                 -wavelet[k1][k2][i3].E+
                 -wavelet[k1][k2][i3].F+
                 wavelet[k1][k2][i3].G)*(waveletScale[k1][k2][i3]);

          xD8 = (-wavelet[k1][k2][k3].A+
                 -wavelet[k1][k2][k3].B+
                 -wavelet[k1][k2][k3].C+
                 wavelet[k1][k2][k3].D+
                 wavelet[k1][k2][k3].E+
                 wavelet[k1][k2][k3].F+
                 -wavelet[k1][k2][k3].G)*(waveletScale[k1][k2][k3]);


          xScalingPrev[i1][i2][i3] = (y[i1][i2][i3]+xD1 +
				      y[i1][i2][k3]+xD2 +
				      y[i1][k2][i3]+xD3 +
				      y[i1][k2][k3]+xD4 +
				      y[k1][i2][i3]+xD5 +
				      y[k1][i2][k3]+xD6 +
				      y[k1][k2][i3]+xD7 +
				      y[k1][k2][k3]+xD8)/8.0;

        }
      }
    }
    for (i1 = 0; i1 < m1; i1++) {
      for (i2 = 0; i2 < m2; i2++) {
        for (i3 = 0; i3 < m3; i3++) {
          y[i1][i2][i3] = xScalingPrev[i1][i2][i3];
	  waveletScale[i1][i2][i3] = waveletScaleNext[i1][i2][i3];
        }
      }
    }
    printf("pruned level %d\n",iL);
  }
}
